using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace BasicSteemaTeechart
{
    public partial class Form1 : Form
    {
        Steema.TeeChart.Tools.CursorTool ct = null;

        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
            this.tChart1.AfterDraw += new Steema.TeeChart.PaintChartEventHandler(tChart1_AfterDraw);
            this.tChart1.BeforeDrawAxes += new Steema.TeeChart.PaintChartEventHandler(tChart1_BeforeDrawAxes);
        }

        void tChart1_BeforeDrawAxes(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            //Steema.TeeChart.Axis a = sender as Steema.TeeChart.Axis;
            //if (a != null &&
            //    a.Horizontal == false)
            {
                double minval = this.tChart1.Axes.Left.MinYValue;
                double maxval = this.tChart1.Axes.Left.MaxYValue;
            }
        }

        void tChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            if (this.tChart1.Axes.Left.Labels.Items.Count > 0)
            {
                double first = (this.tChart1.Chart.Axes.Left.Labels.Items[0]).Value;
                double last = (this.tChart1.Chart.Axes.Left.Labels.Items[this.tChart1.Axes.Left.Labels.Items.Count - 1]).Value;
                bool auto = this.tChart1.Axes.Left.Automatic;
            }
        }

        void Form1_Load(object sender, EventArgs e)
        {
            ct = new Steema.TeeChart.Tools.CursorTool(this.tChart1.Chart);
            ct.Active = true;
            this.tChart1.Legend.Visible = true;
            this.tChart1.Legend.Alignment = Steema.TeeChart.LegendAlignments.Top;
            this.tChart1.Legend.Text= "Legend";
            this.tChart1.Legend.CheckBoxes = true;
            //this.tChart1.Panel.MarginTop = 30;

            CreateChart4();
            //CreateChart2();

            //this.tChart1.Axes.Left.MaximumOffset = this.tChart1.Axes.Left.IAxisSize * (10 / 100);
            //this.tChart1.Axes.Left.MinimumOffset = this.tChart1.Axes.Left.IAxisSize * (10 / 100);
            //this.tChart1.Axes.Left.MaximumOffset = 20;
            //this.tChart1.Axes.Left.MinimumOffset = 20;
            //this.tChart1.Panel.MarginTop += 10;
            //this.tChart1.Panel.MarginBottom += 10;

            //this.tChart1.Axes.Left.AutomaticMaximum = false;
            //this.tChart1.Axes.Left.AutomaticMinimum = false;
        }

 

        private void CreateChart1()
        {
            Steema.TeeChart.Styles.Line line = new Steema.TeeChart.Styles.Line(this.tChart1.Chart);
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.DownTriangle;
            line.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dot;

            line.Pointer.Color = Color.Black;
            line.Pointer.HorizSize = 2;
            line.Pointer.VertSize = 2;
            line.Pointer.Visible = true;
            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);


            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);
            List<int> valList = new List<int>(new int[]{64, 67, 70, 72, 74, 75, 60, 58, 57, 56, 59, 63});
            foreach (int val in valList)
            {
                line.Add(wd, val);
                wd = wd.Add(OneHour);

            }
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Green;


        }

        private void CreateChart2()
        {
            Steema.TeeChart.Styles.Line line = new Steema.TeeChart.Styles.Line(this.tChart1.Chart);
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.Circle;
            line.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dot;

            line.Pointer.Color = Color.Red;
            line.Pointer.HorizSize = 2;
            line.Pointer.VertSize = 2;
            line.Pointer.Visible = true;
            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);


            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);
            List<int> valList = new List<int>(new int[] { 64, 67, 70, 71, 72, 72 });
            foreach (int val in valList)
            {
                line.Add(wd, val);
                wd = wd.Add(OneHour);

            }
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Red;

            this.tChart1.Axes.Left.MaximumOffset = this.tChart1.Chart.Axes.Left.IAxisSize * (3 / 100);
            this.tChart1.Axes.Left.MinimumOffset = this.tChart1.Chart.Axes.Left.IAxisSize * (3 / 100);
        }

        private void CreateChart4()
        {
            Steema.TeeChart.Styles.Line line = new Steema.TeeChart.Styles.Line(this.tChart1.Chart);
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.DownTriangle;
            line.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dot;
            line.ColorEachLine = true;
            //line.ColorEach = true;

            line.Pointer.Color = Color.Black;
            line.Pointer.HorizSize = 2;
            line.Pointer.VertSize = 2;
            line.Pointer.Visible = true;
            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);


            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);
            List<int> valList = new List<int>(new int[] { 81, 81, 81, 13, 13, 13, 13, 53, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 101 });
            foreach (int val in valList)
            {
                line.Add(wd, val);
                wd = wd.Add(OneHour);

            }
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Green;

            line.GetPointerStyle += new Steema.TeeChart.Styles.CustomPoint.GetPointerStyleEventHandler(lineSeries_GetPointerStyle);


        }
        private void CreateChart()
        {
            Steema.TeeChart.Styles.Line line = new Steema.TeeChart.Styles.Line(this.tChart1.Chart);
            line.Pointer.Style = Steema.TeeChart.Styles.PointerStyles.DownTriangle;
            line.Pointer.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dot;
            //line.Pointer.Pen.Width = 5;
            //line.Pointer.Pen.DrawingPen.Width = 1;
            line.Pointer.Color = Color.Black;
            line.Pointer.HorizSize = 5;
            line.Pointer.VertSize = 5;
            line.Pointer.Visible = true;
            DateTime wd = DateTime.Now;
            TimeSpan TwentyHours = new TimeSpan(40, 0, 0);
            TimeSpan OneHour = new TimeSpan(1, 0, 0);

            // Not 3D!
            this.tChart1.Aspect.View3D = false;

            wd.Subtract(TwentyHours);

            for (int i = 1; i < 20; i++)
            {
                line.Add(wd, i);
                wd = wd.Subtract(OneHour);

                line.Add(wd, i);
                wd = wd.Subtract(OneHour);
            }
            //((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Style = Steema.TeeChart.Styles.PointerStyles.Triangle;
            //((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Width = 1;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Pointer.Pen.Color = Color.Pink;
            //((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).LinePen.Color = Color.Green;
            ((Steema.TeeChart.Styles.Line)this.tChart1.Series[0]).Color = Color.Green;
        }

        static int iSequence = 0;
        static int iSampleCount = 0;
        void lineSeries_GetPointerStyle(Steema.TeeChart.Styles.CustomPoint series, Steema.TeeChart.Styles.CustomPoint.GetPointerStyleEventArgs e)
        {
            Color col = System.Drawing.Color.Empty;
            System.Drawing.Drawing2D.DashStyle style = System.Drawing.Drawing2D.DashStyle.Solid;

            switch (iSequence)
            {
                case 0:
                    col = Color.Red;
                    style = System.Drawing.Drawing2D.DashStyle.Dash;
                    break;
                case 1:
                    col = Color.Green;
                    style = System.Drawing.Drawing2D.DashStyle.Dot;
                    break;
                case 2:
                    col = Color.Orange;
                    style = System.Drawing.Drawing2D.DashStyle.Solid;
                    break;
            }


            if (iSequence >= 2)
                iSequence = 0;
            else
                iSequence++;

            if (iSampleCount >= series.Count)
            {
                iSequence = 0;
                iSampleCount = 0;
            }
            else
                iSampleCount++;

            series.Pointer.Color = col;
            series.Pointer.Pen.Color = series.Pointer.Color;
            series.Color = col;
            series.LinePen.Style = style;
        }
    }
}